<?php
/**
 * Paymnet Gateway SpryPay for SocialEngine 4
 *
 * @category   Engine
 * @package    Engine_Payment
 * @version    1.0
 * @author     sprypay.ru
 */

class Engine_Payment_Gateway_Sprypay extends Engine_Payment_Gateway
{
  // Support

  protected $_supportedCurrencies = array(
  	'RUB',
  	'UAH',
    'EUR',
    'USD'
  );

  protected $_supportedLanguages = array(
    'en' => 'en',
    'ru' => 'ru',
  );

protected $_supportedRegions = array(
    'AF', 'AX', 'AL', 'DZ', 'AS', 'AD', 'AO', 'AI', 'AQ', 'AG', 'AR', 'AM',
    'AW', 'AU', 'AT', 'AZ', 'BS', 'BH', 'BD', 'BB', 'BY', 'BE', 'BZ', 'BJ',
    'BM', 'BT', 'BO', 'BA', 'BW', 'BV', 'BR', 'IO', 'BN', 'BG', 'BF', 'BI',
    'KH', 'CM', 'CA', 'CV', 'KY', 'CF', 'TD', 'CL', 'CN', 'CX', 'CC', 'CO',
    'KM', 'CG', 'CD', 'CK', 'CR', 'CI', 'HR', 'CU', 'CY', 'CZ', 'DK', 'DJ',
    'DM', 'DO', 'EC', 'EG', 'SV', 'GQ', 'ER', 'EE', 'ET', 'FK', 'FO', 'FJ',
    'FI', 'FR', 'GF', 'PF', 'TF', 'GA', 'GM', 'GE', 'DE', 'GH', 'GI', 'GR',
    'GL', 'GD', 'GP', 'GU', 'GT', 'GG', 'GN', 'GW', 'GY', 'HT', 'HM', 'VA',
    'HN', 'HK', 'HU', 'IS', 'IN', 'ID', 'IR', 'IQ', 'IE', 'IM', 'IL', 'IT',
    'JM', 'JP', 'JE', 'JO', 'KZ', 'KE', 'KI', 'KP', 'KR', 'KW', 'KG', 'LA',
    'LV', 'LB', 'LS', 'LR', 'LY', 'LI', 'LT', 'LU', 'MO', 'MK', 'MG', 'MW',
    'MY', 'MV', 'ML', 'MT', 'MH', 'MQ', 'MR', 'MU', 'YT', 'MX', 'FM', 'MD',
    'MC', 'MN', 'MS', 'MA', 'MZ', 'MM', 'NA', 'NR', 'NP', 'NL', 'AN', 'NC',
    'NZ', 'NI', 'NE', 'NG', 'NU', 'NF', 'MP', 'NO', 'OM', 'PK', 'PW', 'PS',
    'PA', 'PG', 'PY', 'PE', 'PH', 'PN', 'PL', 'PT', 'PR', 'QA', 'RE', 'RO',
    'RU', 'RW', 'SH', 'KN', 'LC', 'PM', 'VC', 'WS', 'SM', 'ST', 'SA', 'SN',
    'CS', 'SC', 'SL', 'SG', 'SK', 'SI', 'SB', 'SO', 'ZA', 'GS', 'ES', 'LK',
    'SD', 'SR', 'SJ', 'SZ', 'SE', 'CH', 'SY', 'TW', 'TJ', 'TZ', 'TH', 'TL',
    'TG', 'TK', 'TO', 'TT', 'TN', 'TR', 'TM', 'TC', 'TV', 'UG', 'UA', 'AE',
    'GB', 'US', 'UM', 'UY', 'UZ', 'VU', 'VE', 'VN', 'VG', 'VI', 'WF', 'EH',
    'YE', 'ZM',
  );

 protected $_supportedBillingCycles = array(
    /* 'Day', */ 'Week', /* 'SemiMonth',*/ 'Month', 'Year',
  );
  // Translation

  protected $_transactionMap = array();
  // General

  /**
   * Constructor
   *
   * @param array $options
   */
  public function  __construct(array $options = null)
  {
    parent::__construct($options);

    if( null === $this->getGatewayMethod() ) {
      $this->setGatewayMethod('POST');
    }
  }

  public function getService()
  {
    return null;
  }

  public function  getGatewayUrl()
  {
     return 'http://sprypay.ru/sppi/';
  }


  public function getShopId()
  {

      $info['shop_id']= $this->getConfig('shop_id');

      return $info['shop_id'];

  }

  public function getSecretKey()
  {
    $info['secret_key']= $this->getConfig('secret_key');
      return $info['secret_key'];

  }



  // Processing

  public function processIpn(Engine_Payment_Ipn $ipn)
  {
    // Validate ----------------------------------------------------------------

    // Get raw data
    $rawData = $ipn->getRawData();

    $this->_log(print_r($rawData, true), Zend_Log::DEBUG);

    // Check for empty parameters
    if( !isset($rawData['spPaymentId']) ) {
      print('error Unable to validate IPN: spPaymentId is missing.');
      return false;
    }
    if( !isset($rawData['spShopId']) ) {
      print('error Unable to validate IPN: spShopId is missing.');
      return false;
    }
    if( !isset($rawData['spShopPaymentId']) ) {
      print('error Unable to validate IPN: spShopPaymentId is missing.');
      return false;
    }
    if( !isset($rawData['spAmount']) ) {
      print('error Unable to validate IPN: spAmoubnt is missing.');
      return false;
    }
    if( !isset($rawData['spHashString']) ) {
      print('error Unable to validate IPN: md5_hash is missing.');
      return false;
    }
    $secret_key=$this->getSecretKey();
    // Validate hash
    $givenHash = $rawData['spHashString'];

    $expectedHash = md5($rawData['spPaymentId'] . $rawData['spShopId'] . $rawData['spShopPaymentId'] . $rawData['spBalanceAmount'] .
    			        $rawData['spAmount'] .$rawData['spCurrency'] .$rawData['spCustomerEmail'] .
    			        $rawData['spPurpose'] .$rawData['spPaymentSystemId'] .$rawData['spPaymentSystemAmount'] .
    			        $rawData['spPaymentSystemPaymentId'] .$rawData['spEnrollDateTime'] . $secret_key);

    if( $givenHash !== $expectedHash ) {
      print('error Unable to validate IPN: hashes do not match - given: ' . $givenHash. ', expected: '.
           $expectedHash);
      return false;
    }

    // Process data ------------------------------------------------------------
    $data = $rawData;

    return $data;
  }



  // Transaction
  public function processTransaction(Engine_Payment_Transaction $transaction)
  {
    $data = array();
    $rawData = $transaction->getRawData();
    // Process data ------------------------------------------------------------

    // Add vendor identity
    // Note: we can get this from the product info
 	$data['spShopId'] = $this->getShopId();



    // A9dd language
    if( (isset($rawData['language']) &&  ($language = $this->isSupportedLanguage($rawData['language']))) ||
        ($language = $this->getLanguage()) )
    {
      $data['lang'] = $language;
    }
	// Add currency
	  if( !empty($rawData['currency']) &&
       ($currency = $this->isSupportedCurrency($rawData['currency'])) ||
        ($currency = Engine_Api::_()->getApi('settings', 'core')->payment['currency']) ) {
       	if($currency=="RUB") $data['spCurrency']="rur";
       	else $data['spCurrency'] = strtolower($currency);
    }

    // Add amount
	if( isset($rawData['amount']) ) {
      $data['spAmount'] = $rawData['amount'];
    }
    // Add return_url
    if( isset($rawData['return_url']) ) {
      $data['spSuccessUrl'] = $rawData['return_url'];
      $data['spSuccessMethod'] = 1;
    }
    if( isset($rawData['cancel_url']) ) {
      $data['spFailUrl'] = $rawData['cancel_url'];
      $data['spFailMethod'] = 1;
    }
    if( isset($rawData['ipn_url']) ) {
      $data['spIpnUrl'] = $rawData['ipn_url'];
      $data['spIpnMethod'] = 1;
    }
    // Add merchant_order_id
    if( isset($rawData['merchant_order_id']) ) {
      if( strlen($rawData['merchant_order_id']) > 6 ) {
        throw new Engine_Payment_Gateway_Exception('spShopId cannot be longer than 6 character.');
      }
      $data['spShopId'] = $rawData['merchant_order_id'];
    } else if( isset($rawData['vendor_order_id']) ) {
      if( strlen($rawData['vendor_order_id']) > 50 ) {
        throw new Engine_Payment_Gateway_Exception('vendor_order_id cannot be longer than 50 character.');
      }
      $data['spShopPaymentId'] = $rawData['vendor_order_id'];
      $data['spPurpose'] = 'Order #'.$rawData['vendor_order_id'];
    }
	$data['src'] = '1';
    // Validate data -----------------------------------------------------------
    if( empty($data['spShopPaymentId']) ) {
      $this->_throw(sprintf('Missing parameter: %1$s', 'spShopPaymentId'));
      $this->_throw('No product identity provided');
      return false;
    }

    if( empty($data['spAmount']) ) {
      $this->_throw(sprintf('Missing parameter: %1$s', 'spAmount'));
      return false;
    }

    if( empty($data['spPurpose']) ) {
      $this->_throw(sprintf('Missing parameter: %1$s', 'spPurpose'));
      return false;
    }

    return $data;
  }


  // Admin

  public function test()
  {
    return $this;
  }

}
